/*********************************************************************
 * strcasecmp.c - Replacement for strcasecmp()
 *********************************************************************
 * This file is part of the package paco
 * Copyright (C) 2005 David Rosal <david.rosal@upf.edu>
 * For more information visit http://paco.sourceforge.net
 *********************************************************************/
/* vim: set ts=4 */

#if !HAVE_STRCASECMP

#include "util.h"


/* Convert a string to lower case */
static void str_tolower(const char *s, char *lower)
{
	int i;
	
	for (i = 0; s[i]; i++)
		lower[i] = tolower(s[i]);
	lower[i] = '\0';
}


/* strcasecmp() emulator */
int strcasecmp(const char *a, const char *b)
{
	if (!a || !b)
		return 0;
	
	char alower[strlen(a) + 1], blower[strlen(b) + 1];
	
	str_tolower(a, alower);
	str_tolower(b, blower);
	
	return strcmp(alower, blower);
}

#endif  /* !HAVE_STRCASECMP  */
